//---------------------------------------------------------------------------

#include <vcl.h>
#include <math.h>
#pragma hdrstop

#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
float lev[5]={0.15,0.3,0.45,0.6,0.75};
int Nmax=100;
float Scale=2.0/Nmax;

float fun(float x, float y)
{
 return (cos(x)*sin(sqrt(x*x+y*y)));
}

float FindPoint(float w1, float w2, float lev, int p1, int p2)
{
 if (w2>w1)
  if (lev>w2 || lev<w1) return (-1);
  else return (0.5+p1+(p2-p1)*(lev-w1)/(w2-w1));
 if (w2<w1)
  if (lev<w2 || lev>w1) return (-1);
  else return (0.5+p2+(p1-p2)*(lev-w2)/(w1-w2));
 if (w1==lev) return (p1); else return (-1);
}

void Contour1(TCanvas *Canvas,int p[4][2], float w[4], float lev)
{
// numeracja punktow
//      P0-----P3
//      |       |
//      |       |
//      P1-----P2
 float d[4];
 d[0]=FindPoint(w[0],w[1],lev,p[0][1],p[1][1]);
 d[1]=FindPoint(w[1],w[2],lev,p[1][0],p[2][0]);
 d[2]=FindPoint(w[2],w[3],lev,p[2][1],p[3][1]);
 d[3]=FindPoint(w[3],w[0],lev,p[3][0],p[0][0]);
 if (d[0]>-1)
 {
  Canvas->MoveTo(p[0][0],d[0]);
   if (d[1]>-1) Canvas->LineTo(d[1]+1,p[1][1]+1);
    else if (d[2]>-1) Canvas->LineTo(p[2][0],d[2]);
    else if (d[3]>-1) Canvas->LineTo(d[3],p[3][1]);
 }
 else
 if (d[1]>-1)
 {
  Canvas->MoveTo(d[1],p[1][1]);
   if (d[2]>-1) Canvas->LineTo(p[2][0],d[2]);
    else if (d[3]>-1) Canvas->LineTo(d[3],p[3][1]);
 }
 else
 if (d[2]>-1)
 {
  Canvas->MoveTo(p[2][0],d[2]);
   if (d[3]>-1) Canvas->LineTo(d[3],p[3][1]);
 }
}

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::fufdu1Click(TObject *Sender)
{
 int a;
 a=5;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormPaint(TObject *Sender)
{
 int i,j,k;
 float d=500.0/Nmax;
 int p[4][2];
 float w[4];

 for (i=0; i<Nmax; i++)
  for (j=0; j<Nmax; j++)
   {
    p[0][0]=d*i; p[0][1]=d*j;
    p[1][0]=d*i; p[1][1]=d*(j+1);
    p[2][0]=d*(i+1); p[2][1]=d*(j+1);
    p[3][0]=d*(i+1); p[3][1]=d*j;
/*
Canvas->MoveTo(p[0][0],p[0][1]);
Canvas->LineTo(p[1][0],p[1][1]);
Canvas->LineTo(p[2][0],p[2][1]);
Canvas->LineTo(p[3][0],p[3][1]);
Canvas->LineTo(p[0][0],p[0][1]);
*/
    w[0]=fun((i-Nmax/2.0)*Scale,(j-Nmax/2.0)*Scale);
    w[1]=fun((i-Nmax/2.0)*Scale,(j+1-Nmax/2.0)*Scale);
    w[2]=fun((i+1-Nmax/2.0)*Scale,(j+1-Nmax/2.0)*Scale);
    w[3]=fun((i+1-Nmax/2.0)*Scale,(j-Nmax/2.0)*Scale);
    for (k=0; k<5; k++)
     Contour1(Canvas,p,w,lev[k]);
   }

}
//---------------------------------------------------------------------------
void __fastcall TForm1::ScrollBar1Change(TObject *Sender)
{
 Nmax=ScrollBar1->Position;
 Scale=float(ScrollBar2->Position)/(10*Nmax);
 Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ScrollBar2Change(TObject *Sender)
{
 Nmax=ScrollBar1->Position;
 Scale=float(ScrollBar2->Position)/(10*Nmax);
 Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
 DoubleBuffered=true;        
}
//---------------------------------------------------------------------------

